; Définition des extensions autorisées
(define TRAITEMENTPARLOT-EXTENSIONS
  '("png" "PNG")
)

; Fonction de traitement par lot
(define (script-fu-traitementparlot nom-repertoire extension)
  ; Fonction chargée de traiter une image
  (define (traiter-image image)
    ; Démarre un niveau de undo
    (gimp-image-undo-group-start image)

  ; Passe en rgb
  (gimp-image-convert-rgb image)

;remplace un bleu par de l’alpha
(plug-in-colortoalpha RUN-NONINTERACTIVE image (car (gimp-image-get-active-drawable image)) '(0 0 131))

    ; Termine le niveau de undo
    (gimp-image-undo-group-end image)
  )

  ; Fonction chargée de traiter un fichier
  (define (traiter-fichier nom-fichier)
    ; Ouverture du fichier
    (let* ((image  (car (gimp-file-load RUN-NONINTERACTIVE nom-fichier nom-fichier)))
           (calque (car (gimp-image-get-active-drawable image)))
          )
      ; Traitement de l’image
      (traiter-image image)

      ; Enregistrement du fichier
      (gimp-file-save RUN-NONINTERACTIVE image calque nom-fichier nom-fichier)

      ; Fermeture du fichier
      (gimp-image-delete image)
    )
  )

  (let* ((extension (list-ref TRAITEMENTPARLOT-EXTENSIONS extension))
         (pattern   (string-append nom-repertoire "/*." extension))
         (fichiers  (cadr (file-glob pattern 0)))
        )
    ; Application de la fonction traiter-fichier à chaque fichier
    (map traiter-fichier fichiers)
  )
)

(script-fu-register "script-fu-traitementparlot"
  "<Image>/Script-Fu/Traitement par lot"
  "Exemple de traitement par lot"
  "Initialement de Frédéric Bisson, modifié par mirandir"
  "Initialement de Frédéric Bisson, modifié par mirandir"
  "2010-04-20"
  ""
  SF-DIRNAME "Répertoire à traiter" ""
  SF-OPTION "Extension" TRAITEMENTPARLOT-EXTENSIONS
)
